#
# spec file for package freetype2 (Version 2.1.10)
#
# Copyright (c) 2010 SUSE LINUX Products GmbH, Nuernberg, Germany.
#
# All modifications and additions to the file contributed by third parties
# remain the property of their copyright owners, unless otherwise agreed
# upon. The license for this file, and modifications and additions to the
# file, is the same license as for the pristine package itself (unless the
# license for the pristine package is not an Open Source License, in which
# case the license is the MIT License). An "Open Source License" is a
# license that conforms to the Open Source Definition (Version 1.9)
# published by the Open Source Initiative.

# Please submit bugfixes or comments via http://bugs.opensuse.org/
#

# norootforbuild


Name:           freetype2
License:        GPL v2 or later
Group:          System/Libraries
AutoReqProv:    on
PreReq:         bash
BuildRequires:  zlib-devel
Version:        2.1.10
Release:        18.23.1
Url:            http://www.freetype.org
Summary:        A TrueType Font Library
Source0:        http://savannah.nongnu.org/download/freetype/freetype-2.1.10.tar.bz2
Source1:        http://savannah.nongnu.org/download/freetype/freetype-doc-2.1.10.tar.bz2
Patch0:         bugzilla-97202-fix-x-crash.patch
Patch1:         enable_ft_optimize_memory.patch
Patch3:         freetype2-bitmap-foundry.patch
Patch4:         ft2-stream-compat.diff
# CJK autofit from upstream CVS
Patch5:         bugzilla-157441-autofit-cjk-cvs.patch
Patch6:         bugzilla-158156-memory-leak.patch
Patch7:         bugzilla-158573-fix-orientation-detection.patch
Patch8:         bugzilla-159166-reduce-embolden-distance.patch
Patch9:         bugzilla-190902-handle-malformed-pcf-files.patch
Patch10:        bugzilla-154928-integer-overflows.patch
Patch258335:    bugzilla-258335.patch
Patch275072:    bugzilla-275072-check-for-negative-points-in-contours.patch
Patch399169:    bugzilla-399169-security.patch
Patch11:        bnc485889-overflow1.patch
Patch13:        bnc485889-overflow3.patch
Patch14:        bnc485889-overflow4.patch
Patch100:       freetype2-bc.patch
Patch1000:      bnc628213_1797.diff
Patch1001:      bnc629447_CVE-2010-2805.diff
Patch1002:      bnc629447_CVE-2010-2806.diff
Patch1003:      bnc629447_CVE-2010-2807.diff
Patch1004:      bnc629447_CVE-2010-2808.diff
#
Patch1005:      bnc619562_CVE-2010-2497.diff
Patch1006:      bnc619562_CVE-2010-2498.diff
Patch1007:      bnc619562_CVE-2010-2499.diff
Patch1008:      bnc619562_CVE-2010-2500.diff
Patch1009:      bnc619562_CVE-2010-2519.diff
Patch1010:      bnc619562_CVE-2010-2520.diff
Patch1011:      bnc619562_CVE-2010-2527.diff
Patch1012:      bnc619562_CVE-2010-2541.diff
#
Patch1013:      bnc633938_CVE-2010-3053.diff
#
Patch1014:      bnc633943_CVE-2010-3054.diff
#
Patch1015:      bnc641580_CVE-2010-3311.diff

BuildRoot:      %{_tmppath}/%{name}-%{version}-build

%description
This library features TrueType fonts for open source projects. This
version also contains an autohinter for producing improved output.



Authors:
--------
    David Turner <david.turner@freetype.org>
    Robert Wilhelm <robert.wilhelm@freetype.org>
    Werner Lemberg <werner.lemberg@freetype.org>

%package devel
License:        GPL v2 or later
Summary:        Include Files and Libraries mandatory for Development.
Group:          Development/Libraries/C and C++
Requires:       %{name} = %{version}
Requires:       zlib-devel

%description devel
This package contains all necessary include files and libraries needed
to develop applications that require these.



Authors:
--------
    David Turner <david.turner@freetype.org>
    Robert Wilhelm <robert.wilhelm@freetype.org>
    Werner Lemberg <werner.lemberg@freetype.org>

%prep
%setup -q -n freetype-%{version} -a 1
%patch0 -p 0
#%patch1 -p 1 -b .enable_ft_optimize_memory
%patch3 -p 1 -b .bitmap-foundry
%patch4 -p 1 -b .ft2-stream-compat
%patch5 -p 1
%patch6 -p 1
%patch7 -p 1
%patch8 -p 1
%patch9 -p 1
%patch10 -p 1
%patch258335 -p 1
%patch275072 -p 1
%patch399169 -p 1
%patch11 -p 1
%patch13 -p 1
%patch14 -p 1
# The byte code interpreter is compiled in by default
# because of the following patch ('%patch100').
# For most fonts it is disabled again by default in the
# fontconfig setup in /etc/fonts. But if it is already 
# enabled at compilation time, it can be easily enabled
# at runtime. See also the variable BYTECODE_BW_MAX_PIXEL
# in /etc/sysconfig/fonts-config.
#
%patch100 -p 1 -b .bytecode

# bnc628213_1797.diff
%patch1000 -p1
# bnc629447_CVE-2010-2805..8.diff
%patch1001 -p1
%patch1002 -p1
%patch1003 -p1
%patch1004 -p1
# bnc619562_CVE-2010-2497..2520.diff
%patch1005 -p1
%patch1006 -p1
%patch1007 -p1
%patch1008 -p1
%patch1009 -p1
%patch1010 -p1
# bnc633938_CVE-2010-3053.diff
%patch1013 -p1
# bnc633943_CVE-2010-3054.diff
%patch1014 -p1
# bnc641580_CVE-2010-3311.diff
%patch1015 -p1

find . -name CVS -type d | xargs rm -rf
find . -name ".cvsignore" | xargs rm -f
%{?suse_update_config:%{suse_update_config -f}}
export CFLAGS="$RPM_OPT_FLAGS -g -fno-strict-aliasing "
make setup CFG="--prefix=/usr --libdir=%{_libdir} --with-zlib"

%build
export CFLAGS="$RPM_OPT_FLAGS -g -fno-strict-aliasing "
make prefix=/usr libdir=%{_libdir} %{?jobs:-j %jobs}

%install
rm -rf $RPM_BUILD_ROOT;
make prefix=$RPM_BUILD_ROOT/usr libdir=$RPM_BUILD_ROOT/%{_libdir} install

%clean
rm -rf $RPM_BUILD_ROOT;

%post -p /sbin/ldconfig

%postun -p /sbin/ldconfig

%files
%defattr(-,root,root)
%doc ChangeLog README
%doc docs/*
%doc freetype-doc-%{version}/docs/*
%{_libdir}/libfreetype.so.*

%files devel
%defattr(-,root,root)
/usr/include/*
%{_libdir}/libfreetype.*a
%{_libdir}/libfreetype.so
%{_libdir}/pkgconfig/freetype2.pc
/usr/bin/*
/usr/share/aclocal/*

%changelog
* Fri Sep 24 2010 jw@novell.com
- added bnc641580_CVE-2010-3311.diff
* Thu Sep 23 2010 jw@novell.com
- fixed bnc#641370, zlib-devel is only a BuildRequires for
  freetype2 and a Requires for freetype2-devel
* Tue Sep 21 2010 jw@novell.com
- added bnc633943_CVE-2010-3054.diff
* Wed Sep 15 2010 jw@novell.com
- added bnc633938_CVE-2010-3053.diff
* Wed Aug 11 2010 jw@novell.com
- added bnc619562_CVE-2010-2497,2498,2499,2500,2519,2520.diff
* Tue Aug 10 2010 jw@novell.com
- added bnc629447_CVE-2010-2805..8.diff
* Mon Aug  9 2010 jw@novell.com
- CVE-2010-1797: added bnc628213_1797.diff
* Thu Apr 16 2009 nadvornik@suse.cz
- fixed integer overflows [bnc#485889] CVE-2009-0946
* Fri Jun 13 2008 mfabian@suse.de
- bnc#399169: fix multiple vulnerabilities.
* Mon Jun  4 2007 mfabian@suse.de
-  Bugzilla #275072: (from upstream CVS):
  Check for negative number of points in contours. Problem
  reported by Victor Stinner <victor.stinner@haypocalc.com>.
* Mon Apr  2 2007 mfabian@suse.de
- Bugzilla #259144: add "PreReq: bash".
* Wed Mar 28 2007 mfabian@suse.de
- Bugzilla #258335: fix buffer overflow in handling of bdf fonts.
* Mon Jul 24 2006 mfabian@suse.de
- Bugzilla #190902: handle malformed pcf files.
* Thu Jun  1 2006 mfabian@suse.de
- Bugzilla #154928: fix several integer overflows.
* Tue Mar 21 2006 dmueller@suse.de
- build parallel
* Mon Mar 20 2006 zsu@suse.de
- Bugzilla #158573: fix corrupt embolden glyphs issue for CJK fonts.
- Bugzilla #159166: reduce embolden strength to get better rendering
  effect.
* Wed Mar 15 2006 mfabian@suse.de
- Bugzilla #157441:  remove 0x0100-0xFFFF from CJK Unicode range,
  as it might cause side effects for non-CJK scripts.
* Wed Mar 15 2006 mfabian@suse.de
- Bugzilla #158156: fix a memory leak (by Zhe Su <zsu@novell.com>).
* Tue Mar 14 2006 mfabian@suse.de
- Bugzilla #157441: instead of Takashi's patches, use a patch
  from upstream CVS which renders slightly better.
* Tue Mar 14 2006 mfabian@suse.de
- Bugzilla #157441: FZSongTi.ttf contains a lot more (CJK)-glyphs
  than most other fonts, therefore we have to expand the cjk range
  in Takashi Iwai's "ft2-autofit-02-cjk.diff" to render these
  glyphs correctly as well.
- Bugzilla #157441: don't apply ft2-autofit-03-latin-baseline.diff
  as it has some side effects.
* Wed Jan 25 2006 mls@suse.de
- converted neededforbuild to BuildRequires
* Mon Jan  9 2006 mfabian@suse.de
- Bugzilla #105626: add patches by Takashi IWAI <tiwai@suse.de>
  to improve the autohinting (mainly for CJK fonts).
* Wed Jul 20 2005 mfabian@suse.de
- Bugzilla #97202: apply workaround to avoid crashing the Xserver.
  I need to disable FT_OPTIMIZE_MEMORY again to apply that
  workaround.
* Tue Jul 19 2005 mfabian@suse.de
- enable FT_OPTIMIZE_MEMORY.
- enable the byte code interpreter again.
* Tue Jul 12 2005 mfabian@suse.de
- update to 2.1.10.
  + fixes serious bug introduced in 2.1.8 which caused many
    distortions for TrueType fonts
  + amount of heap memory used is drastically reduced
  For more details see /usr/share/doc/packages/freetype2/CHANGES.
- disable freetype-autohint-cjkfonts.patch for the moment, the
  auto-hinter has been replaced with a new module called the
  'auto-fitter' which is "prepared better to support non-latin1
  scripts in next releases". Currently the rendering quality of
  CJK fonts seems to have suffered though compared to 2.1.9
  with the freetype-autohint-cjkfonts.patch.
* Mon Jul  4 2005 meissner@suse.de
- Use system zlib.
* Wed Aug 25 2004 kukuk@suse.de
- Avoid /bin/sh as PreRequires
* Tue Jul  6 2004 mfabian@suse.de
- update to 2.1.9.
* Mon May 10 2004 mfabian@suse.de
- update to 2.1.8.
  remove the bdf-pcf fixes for bitmap font metric issues which
  were backported from CVS, they are included in this release
* Fri Apr 16 2004 mfabian@suse.de
- Bugzilla #38205:
  add patch from http://www.kde.gr.jp/~akito/patch/freetype2/2.1.7
  to improve the hinting results (mainly for CJK fonts).
* Wed Mar 24 2004 mfabian@suse.de
- Add ft2-stream-compat.diff for binary compatibility when
  upgrading from SLES8 to SLES9.
  The FT_Stream functions have been renamed and although these
  functions were declared for internal use only by the freetype
  developers, they have been used in Qt (and possibly elsewhere).
  Therefore, 3rd party which linked statically against Qt might
  not work after upgrading from SLES8 to SLES9.
  Fix this problem with a patch by Kurt Garloff <garloff@suse.de>
  which defines appropriate weak symbols.
* Tue Mar 16 2004 mfabian@suse.de
- fix Bugzilla# 36143: backport fixes for bitmap font metric issues
  from CVS to fix  crashes when using bitmap fonts caused by the
  new libXft-2.1.5 from the X.org tree.
* Mon Jan 12 2004 adrian@suse.de
- add %%defattr and %%run_ldconfig
* Fri Jan  9 2004 mfabian@suse.de
- add "-fno-strict-aliasing" compile option to prevent crashes
  for example in ftdump and mkfontscale.
* Tue Dec 16 2003 mfabian@suse.de
- update to 2.1.7.
- remove freetype2-type1.patch (included upstream)
- add documentation.
* Wed Oct  8 2003 schwab@suse.de
- Fix invalid free.
* Fri Sep 26 2003 mfabian@suse.de
- update to 2.1.5.
- remove freetype-bdf-pcf-drivr.patch, freetype2-bitmap-style.patch
  (included upstream).
- remove gzip-eof.patch.
* Mon Sep  1 2003 mfabian@suse.de
- add gzip-eof.patch to fix the problem that some gzipped bitmap
  fonts could not be opened by freetype2.
  See also:
  http://marc.theaimsgroup.com/?l=freetype-devel&m=105505219505600&w=2
  and followups.
* Tue Aug 26 2003 mfabian@suse.de
- add freetype2-bitmap-style.patch: check the bdf properties
  WEIGHT_NAME and SLANT case insensitively. Without that,
  these properties are not correctly recognized when the fonts
  specify them in lower case.
* Tue Apr  8 2003 mfabian@suse.de
- update to 2.1.4
* Fri Apr  4 2003 mfabian@suse.de
- update to 2.1.4rc2
- freetype2-gzip-header.patch is obsolete -> removed
* Fri Mar  7 2003 mfabian@suse.de
- Bug #24755: further improvement: add " Wide" to the family name
  for fonts which have an average width >= point size, i.e. fonts
  which have glyphs which are at least square (or maybe even
  wider). This makes fonts which contain only double width
  characters (for example the "misc-fixed" 18x18ja.bdf) clearly
  distinct from single width fonts of the same family and
  avoids that they get accidentally selected via freetype2/Xft2.
* Fri Mar  7 2003 mfabian@suse.de
- Bug #24775: partly fixed by a patch to freetype which returns
  "FOUNDRY FAMILY_NAME" as the family_name for bitmap fonts.
  Without that change, all bitmap fonts which have "Fixed"
  in FAMILY_NAME also had the same family_name "Fixed" via
  freetype/Xft2 and it was not possible to distinguish between
  them, therefore the selection of "Fixed" bitmap fonts produced
  quite surprising results. After this change, the fonts show
  up for example as "Misc Fixed", "Etl Fixed", etc. via
  freetype2/Xft2, which makes it easy to select the right one.
* Mon Mar  3 2003 mfabian@suse.de
- fix for the bug that caused FreeType to loop endlessly when
  trying to read certain compressed gzip files. The following test
  could be used to reveal the bug:
  touch 0123456789 ; gzip 0123456789 ; ftdump 0123456789.gz
  (from upstream CVS)
* Fri Feb 14 2003 mfabian@suse.de
- freetype-bdf-pcf-drivr.patch: use FT_UShort instead of FT_Short
  for the glyph number of bitmap fonts. The GNU Unicode font
  has 34725 glyphs and because of the usage of signed short
  all glyphs with an index above 2^15 couldn't be displayed.
  Thanks to Gerd Knorr <kraxel@suse.de>.
* Thu Jan 30 2003 mfabian@suse.de
- disable freetype2-bc.patch, see
  http://www.freetype.org/freetype2/2.1.3-explained.html
* Wed Jan 29 2003 mfabian@suse.de
- add freetype2-bc.patch
* Mon Jan 13 2003 mfabian@suse.de
- split out ft2demos into extra package to avoid adding
  x-devel-packages to '# neededforbuild' (XFree86 needs freetype2,
  this would be a loop in the requirements)
- add doc files and license texts.
* Fri Jan 10 2003 mfabian@suse.de
- fix checking of .gz header (fixes Bug #22712, i.e. fixes
  the problem that freetype2 couldn't open .pcf.gz files which
  contain the original file name or extra fields)
- add programs from ft2demos-2.1.3.
* Thu Nov 21 2002 mfabian@suse.de
- update to 2.1.3.
* Tue Nov  5 2002 mfabian@suse.de
- add /usr/share/aclocal/* to filelist
  (thanks to <adrian@suse.de> for noticing the omission)
* Thu Oct 24 2002 mfabian@suse.de
- update to 2.1.2. From the release notes:
  That's probably the first release of FreeType in the 2.1.x
  development branch that can safely replace 2.0.9 on any
  system.
* Fri Aug  9 2002 mfabian@suse.de
- freetype2-devel package should require freetype2 package
* Tue Apr  2 2002 mfabian@suse.de
- upgrade to 2.0.9 (considerably improved rendering of Type1 fonts)
* Wed Mar  6 2002 mfabian@suse.de
- use the byte code interpreter
* Mon Feb 11 2002 mfabian@suse.de
- upgrade to 2.0.8
- remove freetype-config.patch (included upstream)
* Tue Feb  5 2002 adrian@suse.de
- enable debug informations to debug a sig11 in inst-sys
* Tue Feb  5 2002 pmladek@suse.cz
- fixed missing 'fi' in freetype-config
* Mon Feb  4 2002 mfabian@suse.de
- update to 2.0.7
- remove freetype-2.0.6-gsf-segv.patch (included in 2.0.7 already)
* Tue Jan 29 2002 mfabian@suse.de
- add freetype-2.0.6-gsf-segv.patch from upstream CVS to prevent
  SEGV caused by gsf files.
* Tue Jan 22 2002 mfabian@suse.de
- use %%{_libdir} instead of /usr/lib
* Wed Jan 16 2002 adrian@suse.de
- updated to 2.0.6
  * important fixes which causes crashes with pfb fonts
  * improved rendering
* Fri Nov  9 2001 mfabian@suse.de
- updated to 2.0.5
* Sat Jul 21 2001 egger@suse.de
- Updated to version 2.0.4.
- Use RPM_OPT_FLAGS.
* Wed Jun  6 2001 egger@suse.de
- Fix filelist.
* Mon Jun  4 2001 egger@suse.de
- Updated to version 2.0.3.
* Mon Mar 26 2001 ro@suse.de
- fix build-rooting
* Thu Dec 14 2000 kukuk@suse.de
- split devel package
* Mon Dec 11 2000 egger@suse.de
- Updated to version 2.0.1.
* Fri Nov 10 2000 egger@suse.de
- Initial SuSE package.
